/*
ID: espr1t
TASK: KHX Tournament
KEYWORDS: Medium, Meet-in-the-Middle
*/

#include <cstdio>
#include <cmath>
#include <iostream>
#include <string>
#include <map>

using namespace std;

const int MAX = 100;
const int LEN = 22;

int n, k;
int a[MAX][LEN];

const int points[3][3] = {
    {0, +1, -1}, // Rock
    {-1, 0, +1}, // Paper
    {+1, -1, 0}  // Scissors
};

int play(int* p1, int* p2, int numRounds) {
    int score = 0;
    for (int i = 0; i < numRounds; i++)
        score += points[p1[i]][p2[i]];
    return score;
}

long long solve() {
    if (k == 1) {
        for (int i = 1; i < n; i++)
            if (a[i][0] != a[0][0])
                return 0;
        return 1;
    }

    long long ans = 0;
    string results(n, 'A');
    map <string, long long> q;
    int leftHalf = k / 2, rightHalf = k - k / 2;
    
    // Left half
    int leftMasks = pow(3, leftHalf);
    for (int mask = 0; mask < leftMasks; mask++) {
        int cur[LEN];
        for (int i = 0, tmp = mask; i < leftHalf; i++, tmp /= 3)
            cur[i] = tmp % 3;
        
        for (int i = 0; i < n; i++)
            results[i] = 'A' - play(cur, a[i], leftHalf);
        q[results]++;
    }
    
    // Right half
    int rightMasks = pow(3, rightHalf);
    for (int mask = 0; mask < rightMasks; mask++) {
        int cur[LEN];
        for (int i = 0, tmp = mask; i < rightHalf; i++, tmp /= 3)
            cur[i] = tmp % 3;
        
        for (int i = 0; i < n; i++)
            results[i] = 'A' + play(cur, a[i] + leftHalf, rightHalf);
        if (q.find(results) != q.end())
            ans += q[results];
    }
    return ans;
}

int main(void) {
//    freopen("KHXTournament.in", "rt", stdin);

    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        char buff[32];
        cin >> buff;
        for (int c = 0; c < k; c++)
            a[i][c] = buff[c] == 'K' ? 0 : (buff[c] == 'H' ? 1 : 2);
    }
    cout << solve() << endl;
    return 0;
}
